package com.zipcodewilmington.looplabs;

import java.util.Arrays;

/**
 * Created by leon on 1/29/18.
 * @ATTENTION_TO_STUDENTS You are forbidden from modifying the signature of this class.
 */
public final class IntegerDuplicateDeleter extends DuplicateDeleter<Integer> {


    public IntegerDuplicateDeleter(Integer[] intArray) {
        super(intArray);


    }

    @Override
    public Integer[] removeDuplicates(int maxNumberOfDuplications) {

        Integer[] resultArray= new Integer[array.length];
        Integer count=0;
        for(Integer i=0;i<array.length;i++){
            if(itemcount(array[i]) < maxNumberOfDuplications){
                resultArray[count]=array[i];
                count++;
            }
        }
        return Arrays.copyOfRange(resultArray,0,count);
    }

    @Override
    public Integer[] removeDuplicatesExactly(int exactNumberOfDuplications) {

        Integer[] resultArray= new Integer[array.length];
        int count=0;
        for(Integer i=0;i<array.length;i++){
            if(itemcount(array[i])!= exactNumberOfDuplications){
                resultArray[count]=array[i];
                count++;

            }
        }
        return Arrays.copyOfRange(resultArray,0,count);
    }

    public int itemcount(Integer value){
        int count=0;
        for(Integer element:array){
            if(element.equals(value)){
                count++;
            }
        }
        return count;
    }
}
